#include <iostream>
#include <string>
#include <ctime>

using namespace std;


class datum
{
private:
	int m_den;
	int m_mesic;
	int m_rok;	
public:
	datum(int den, int mesic, int rok):m_den(den), 
					   m_mesic(mesic),
					   m_rok(rok)
	{
	if ((mesic<1)||(mesic>12)) throw "Chybne zadany mesic!";	//parametr throw je zde typu const char* (pole znaku, neni zde string!)
	if (rok<1950) throw "Chybne zadany rok!";
	if ((den>31)||(den<1)) throw "Chybne zadany den";
	if (((mesic==4)||(mesic==6)||(mesic==9)||(mesic==11)) && (den>30)) throw "Chybne zadany den!";
	if ((mesic==2)&&(den>29)) throw "Chybne zadany den!";
	if ((mesic==2)&&(rok%4!=0)&&(den>28)) throw "Chybne zadany den!";
	}
	
	friend ostream& operator<<(ostream &o,const datum & d)
	{
		return o<<d.m_den<<"."<<d.m_mesic<<"."<<d.m_rok;
	}

	int pocetroku(const datum& dnesnidatum) const
	{
		int roky=dnesnidatum.m_rok-m_rok;
		if (dnesnidatum.m_mesic<m_mesic) roky--;
		if ((dnesnidatum.m_mesic==m_mesic)&&(dnesnidatum.m_den<m_den)) roky--;
		return roky;
	}
};

class student
{
private:
	string m_jmeno;
	string m_prijmeni;
	datum m_datnar;
	string m_zeme;
public:
	student(void):m_jmeno(""),			// defaultni konstruktor pro potreby kompilatoru
    		      m_prijmeni(""),
		      m_datnar(datum(1,1,2000)),
		      m_zeme("")	 
	{}

	student(string jmeno, string prijmeni, const datum &datnar, string zeme):m_jmeno(jmeno),
 									  	 m_prijmeni(prijmeni),
										 m_datnar(datnar),
										 m_zeme(zeme)
	{}

	friend ostream& operator<<(ostream &o, const student& s)
	{
		return o<<s.m_jmeno<<" "<<s.m_prijmeni<<", "<<s.m_datnar<<", "<<s.m_zeme;
	}
	
	int vek(const datum& dnesnidatum) const
	{
		return m_datnar.pocetroku(dnesnidatum);
	}

	string zezeme(void) const
	{
		return m_zeme;
	}
};


void nactistudenty(student *studenti, int * pocet)
{
	bool studentnacten;
	string jmeno, prijmeni, zeme;
	int den, mesic, rok;
	char c;
	while (1)
	{
	 	studentnacten=false;
		while (!studentnacten)
		{
			try
			{
				cout <<"Zapis "<<*pocet+1<<" studenta"<<endl;
				cout <<"Zadej jmeno studenta ";
				cin >>jmeno;
				cout <<"Zadej prijmeni studenta ";
				cin >>prijmeni;
				cout <<"Zadej datum narozeni studenta (ve formatu dd.mm.rrrr) ";
				cin >>den>>c>>mesic>>c>>rok;
				if (!cin.good()) throw 5;		//jestni neni spravne zadane datum, tak vyhodime vyjimku 5
				cout <<"Zadej zemi studenta ";
				cin >>zeme;
				studenti[*pocet]=student(jmeno, prijmeni, datum(den,mesic,rok),zeme);
				studentnacten=true;
				*pocet=*pocet+1;		
			}
			catch (const char* chyba)
			{
				cout<<chyba<<endl;
			}
			catch (...)
			{
				cin.clear();					//odstraneni chyboveho stavu
				cin.ignore(1000,'\n');				//ignoruje prvnich 1000 znaku (nebo do prvniho \n) vstupniho streamu
				cout<<"Pri nacitani data nastala chyba..."<<endl; 	//zde nezname typ throw, proto ..
			}
		}
		if (*pocet==20) return;
		while (1)
		{
			cout<<"Zadat dalsiho studenta? A/N";
			cin>>c;
			if ((c=='a')||(c=='A')) break;
			if ((c=='n')||(c=='N')) return;
			cout<<"Nerozumim!"<<endl;
		}
	}
	
}

datum nyni (void)
{
	time_t t=time(nullptr); // stejne jako je v C NULL
	tm* dnesek=localtime(&t);
	return datum(dnesek -> tm_mday, dnesek -> tm_mon+1, dnesek -> tm_year+1900);
}	

int main (void)
{
	int hledanyvek;
	string hledanazeme;
	student studenti[20]; 			// staticky definovano pole pro 20 studentu (20 neni max index, ale pocet prvku typu student)
	int pocetstudentu=0;
	nactistudenty(studenti,&pocetstudentu);	// adresa na prvni prvek pole studenti
	cout <<"Zadej vek pro vypis studentu ";
	cin >>hledanyvek;
	for (int i=0;i<pocetstudentu;i++)
	{
		if (studenti[i].vek(nyni())>=hledanyvek) cout<<studenti[i]<<endl;
	}
	cout <<"Zadej zemi pro vypis studentu ";
	cin >>hledanazeme;
	for (int i=0;i<pocetstudentu;i++)
	{
		if (studenti[i].zezeme()==hledanazeme) cout<<studenti[i]<<endl;
	}
	return 0;
}

